
/* Web Polygraph       http://www.web-polygraph.org/
 * (C) 2003-2006 The Measurement Factory
 * Licensed under the Apache License, Version 2.0 */

#ifndef POLYGRAPH__LOGANALYZERS_LOADTRACEFIG_H
#define POLYGRAPH__LOGANALYZERS_LOADTRACEFIG_H

#include "xstd/String.h"
#include "loganalyzers/ReportTraceFigure.h"

class LoadStex;
class PhaseInfo;
class PhaseTrace;
class StatIntvlRec;

// creates load trace figure based on interval load stats
class LoadTraceFig: public ReportTraceFigure {
	public:
		typedef LoadStex Stex;

	public:
		LoadTraceFig();

		void stats(const Stex *aStex1, const Stex *aStex2, const PhaseInfo *phase);

	protected:
		virtual int createCtrlFile();
		virtual void setCtrlOptions();

		int dumpDataLines(const LoadStex *stex);
		int dumpDataLine(const LoadStex *stex, Time stamp, const StatIntvlRec &r);
		
	protected:
		const Stex *theStex1;
		const Stex *theStex2;
		const PhaseInfo *thePhase;
		const PhaseTrace *theTrace;
};

#endif
