#include	<string.h>
#include	"global.h"
#include	"source.h"


// Input for the source handler is specified as a parameter to the
// constructor function.  The filename "-" is used to denote the
// standard input stream.

Source::Source(const char* fn) : Buffer()
{
	_currentLine = 0;
	if (strcmp(fn, "-") == 0) {
		fd = stdin;
		_fileName = strdup("stdin");
	} else {
		fd = fopen(fn, "r");
		_fileName = strdup(fn);
	}
	_status = (fd ? OK : CANNOTOPEN);
}

Source::~Source()
{
	free(_fileName);
	if (fd != stdin)
		fclose(fd);
}

char Source::nextChar()
{
	if (empty()) {
		char *p = fill();
		if (fgets(p, MAXBUFFERSPACE, fd)) {
			_currentLine++;
			//fprintf(stderr, "%6d    %s", _currentLine, p);
		} else {
			*p++ = (char)EOF;
			*p = '\0';
			_status = SAWEOF;
		}
	}
	return(get());
	
}
